/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example13.c						*
*	Description :: Fibonacci numbers using 'task'				*
*										*
*********************************************************************************/ 
#include <stdio.h>
#include <omp.h>
int fibonacci(int num)
{
  int i, j;
  if (num<2)
    return num;
  else
    {
       #pragma omp task shared(i) firstprivate(num)
       i=fibonacci(num-1);

       #pragma omp task shared(j) firstprivate(num)
       j=fibonacci(num-2);

       #pragma omp taskwait
       return i+j;
    }
}

int main()
{
  int num = 10;

  #pragma omp parallel shared(num)
  {
    #pragma omp single
    printf ("fibonnaci number at %d is %d\n", num, fibonacci(num));
  }
}

