/********************************************************************************	
*										*
*	Program  :: vector7.c							*
*	Description :: Vectorization dependency, use -vec-threshold=0  		*
*										*
*********************************************************************************/ 
#include<stdio.h>
void main()
{
	int temp=0,SIZE=10,array_A[SIZE],array_B[SIZE],array_C[SIZE],array_D[SIZE],index;
	for(index=0;index<SIZE;index++)
	{
		array_A[index]=0;
		array_B[index]=index%2;
		array_D[index]=index%2+1;
		array_C[index]=0;
	}
	#pragma vector alwa
	for(index=0;index<SIZE;index++)
	{
		array_A[array_B[index]]=array_C[array_D[index]];
	}

//Verification loop
	#pragma novector
	{
	for(index=0;index<SIZE;index++)
	{
		if (array_A[array_B[index]]!=array_C[array_D[index]])
		{	temp=1;
			printf("Fail @ %d: Inefficient Vectorized\n",index);
			break;
		}
	}
	}
	if(temp==0)
	printf("Passed:Vectorized efficienty\n");
}	

