/********************************************************************************	
*										*
*	Program  :: vector9.c							*
*	Description ::Guided  Vectorization and functions			*
*										*
*********************************************************************************/ 
#include<stdio.h>
int  factorial(int num)
{
	int num1=1,index,array_D[num];
	for(index=1;index<num;index++)
	num1=num1*index;
	return num1;
}

void main()
{
	int temp=0,SIZE=10,array_A[SIZE],array_B[SIZE],index;
	for(index=0;index<SIZE;index++)
	{
		array_A[index]=0;
		array_B[index]=index;
	}
	#pragma vector always
	for(index=0;index<SIZE;index++)
	{
		#pragma noinline
		array_A[index]=factorial(array_B[index]);
	}

//Verification loop
	#pragma novector
	{
	for(index=0;index<SIZE;index++)
	{
		if (array_A[index]!=factorial(array_B[index]))
		{	temp=1;
			printf("Fail @ %d: Inefficient Vectorized\n",index);
			break;
		}
	}
	}
	if(temp==0)
	printf("Passed:Vectorized efficienty\n");
}	
