/********************************************************************************
*										*
*	Program ::mpi_example8.c						*
*	Description :: Understanding MPI File I/O				*
*										*
*********************************************************************************/ 
#include<stdio.h>
#include<mpi.h>
#include<stdlib.h>
#define SIZE 32
int main(int argc,char** argv)
{	int rank,size,err,i;
	MPI_Status status;
	MPI_File fh;
	MPI_Init(&argc,&argv);
	MPI_Comm_size(MPI_COMM_WORLD,&size);
	MPI_Comm_rank(MPI_COMM_WORLD,&rank);
	char fname[20],*buff;
	buff=(char *)malloc(20);
	sprintf(fname,"temp");
	err=MPI_File_open( MPI_COMM_SELF,fname, MPI_MODE_CREATE | MPI_MODE_WRONLY , MPI_INFO_NULL, &fh );
	if(!err)
	{	int my_off;
		for(i=rank;i<SIZE;i=i+size)
		{	my_off=17*i;
			sprintf(buff,"rank=%03d-num=%03d\n",rank,i);
			MPI_File_write_at(fh,my_off,buff,strlen(buff),MPI_CHAR,&status);
		}
		MPI_File_close( &fh );
	}
		
	else
		printf("ERROR\n");
	
	MPI_Finalize();
	return 0;
	
}
