/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example11.c						*
*	Description :: Illustration for offload and OpenMP			*
*										*
*********************************************************************************/ 
//Standard library
#include<stdio.h>
#include<unistd.h>
#include<omp.h>
void main()
{
	char hostname1[1024],hostname2[1024];
	gethostname(hostname1, 1023);
	int cores2,cores1 = sysconf(_SC_NPROCESSORS_ONLN);
	printf("Hello world! Running on processor = '%s' with %d cores\n",hostname1, cores1); 	 

	//offloading data to Co-processor(Xeon_phi)
	#pragma offload target(mic:0) 
	{
		gethostname(hostname2, 1023);	
		cores2 = sysconf(_SC_NPROCESSORS_ONLN);	
		#pragma omp parallel
		{
		int tid=omp_get_thread_num();
		printf("Hello world!%d Running on co-processor = '%s' with %d logical cores\n",tid,hostname2, cores2);
		}
	}
}
