/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example16.c						*
*	Description :: Illustration of OpenMP 'declare simd' directive 		*
*										*
*********************************************************************************/


#include<stdio.h>
#include<omp.h>

int size=10;

#pragma omp declare simd
int add(int x,int y)
{
	int z;
	z= x+y;
	return z;
}

void main()
{
	int i,a[size],b[size],c[size];
	for(i=0;i<size;i++)
	{
		a[i]=b[i]=i;
	}
	#pragma omp simd
	for(i=0;i<size;i++)
	{
		c[i]=add(a[i],b[i]);
		printf("c[%d]= %d\n",i,c[i]);
	}
	
}
