/********************************************************************************	
*										*
*										*
*	Program  :: openmp_example17.c						*
*	Description :: Illustration of OpenMP 'target' construct  		*
*										*
*********************************************************************************/

#include<stdio.h>
#include<omp.h>

void main()
{

	int a[10],b[10],c[10],i;
	for(i=0;i<10;i++)
	{
		c[i]=a[i]=b[i]=i;
	}
	#pragma omp target map(tofrom: c[0:10]) map(to: a[0:10], b[0:10])
	{
		for(i=0;i<10;i++)
		{
			c[i]=a[i]+b[i];
			printf("On Host?: %d	c[%d]= %d\n",omp_is_initial_device(),i,c[i]);
		}
	}
}//main
