/********************************************************************************	
*										*
*	Program  :: vector1.c							*
*	Description :: Vectorization demonstration example	  		*
*										*
*********************************************************************************/ 
#include<stdio.h>
#include<time.h>
void main()
{
	int SIZE=100000,index,temp=0;
	int array_A[SIZE],array_B[SIZE],array_C[SIZE];
	for(index=0;index<SIZE;index++)
	{
		array_A[index]=0;
		array_B[index]=index*10;
		array_C[index]=index;
	}
	
	for(index=0;index<SIZE;index++)
	{
		array_A[index]= array_B[index]+array_C[index];
	}
	//Verification Loop
	#pragma novector
	{
		for(index=0;index<SIZE;index++)
		{
			if(array_A[index] != array_B[index]+array_C[index])
			{	temp = 1;
				printf( "Failed: Inefficient Vectorization\n" );
				break;
			}		
	}
	}
	if(temp==0)
	printf("Passed: Efficient Vectorization\n");
}
