/********************************************************************************	
*										*
*	Program  :: vector2.c							*
*	Description :: Example illustrating guided vectorisation (SIMD) but 	*
*			yielding incorrect result.		  		*
*										*
*********************************************************************************/ 
#include<stdio.h>
void main()
{
	int temp=0,SIZE=10,array_A[SIZE],array_B[SIZE],array_C[SIZE],index;
	for(index=0;index<SIZE;index++)
	{
		array_A[index]=index;
		array_B[index]=index;
		array_C[index]=index*10;
	}

	#pragma simd
	for(index=0;index<SIZE-1;index++)
	{
		array_A[index+1]=array_A[index]+array_C[index];
	}

//Verification loop
	#pragma novector
	{
	for(index=0;index<SIZE-1;index++)
	{
		array_B[index+1]=array_B[index]+array_C[index];
	}
	for(index=0;index<SIZE-1;index++)
	{
		if(array_A[index]!=array_B[index])
			{temp=1;
			printf("Fail @ %d: Inefficient Vectorized\n",index);
			break;
			}
	}
	}
	if(temp==0)
	printf("Passed:Vectorized efficienty\n");
}	
